## xnnpack 0.0~git20240821.87ee0b4

=== CMakeLists.txt ===
# Copyright (c) Facebook, Inc. and its affiliates.
# All rights reserved.
#
# Copyright 2019 Google LLC
#
# This source code is licensed under the BSD-style license found in the
# LICENSE file in the root directory of this source tree.

CMAKE_MINIMUM_REQUIRED(VERSION 3.15 FATAL_ERROR)

# Allow specifying -D<PackageName>_ROOT.
CMAKE_POLICY(SET CMP0074 NEW)

# MSVC runtime library flags are selected by an abstraction.
CMAKE_POLICY(SET CMP0091 NEW)

# ---[ Project and semantic versioning.
PROJECT(XNNPACK C CXX ASM)

# --[ Use ccache if available
FIND_PROGRAM(CCACHE_BINARY "ccache")
IF(CCACHE_BINARY)
  MESSAGE(STATUS "Using ccache: ${CCACHE_BINARY}")
  SET(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE_BINARY}" CACHE STRING "CXX compiler launcher" FORCE)
  SET(CMAKE_C_COMPILER_LAUNCHER "${CCACHE_BINARY}" CACHE STRING "C compiler launcher" FORCE)
  IF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}")
    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_DEBUG_INIT "${CMAKE_C_FLAGS_DEBU_INITG}")
    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_DEBUG_INIT "${CMAKE_CXX_FLAGS_DEBUG_INIT}")
    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_RELWITHDEBINFO_INIT "${CMAKE_C_FLAGS_RELWITHDEBINFO_INIT}")
    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_RELWITHDEBINFO_INIT "${CMAKE_CXX_FLAGS_RELWITHDEBINFO_INIT}")
  ENDIF()
ENDIF()

SET(CMAKE_C_STANDARD 99)
SET(CMAKE_C_EXTENSIONS NO)
SET(CMAKE_CXX_STANDARD 14)
SET(CMAKE_CXX_STANDARD_REQUIRED YES)
SET(CMAKE_CXX_EXTENSIONS NO)

# ---[ Options.
SET(XNNPACK_LIBRARY_TYPE "default" CACHE STRING "Type of library (shared, static, or default) to build")
SET_PROPERTY(CACHE XNNPACK_LIBRARY_TYPE PROPERTY STRINGS default static shared)
OPTION(XNNPACK_ENABLE_ASSEMBLY "Build XNNPACK with assembly micro-kernels" ON)
OPTION(XNNPACK_ENABLE_MEMOPT "Build XNNPACK with optimized memory allocation scheme" ON)
OPTION(XNNPACK_ENABLE_SPARSE "Build XNNPACK with graph rewriting for sparse inference" ON)
OPTION(XNNPACK_ENABLE_GEMM_M_SPECIALIZATION "Build XNNPACK with support for selecting microkernel with different MR" ON)
OPTION(XNNPACK_ENABLE_DWCONV_MULTIPASS "Build XNNPACK with DWCONV multipass microkernels enabled" OFF)
OPTION(XNNPACK_BUILD_LIBRARY "Build XNNPACK library" ON)
OPTION(XNNPACK_BUILD_TESTS "Build XNNPACK unit tests" ON)
OPTION(XNNPACK_BUILD_ALL_MICROKERNELS "Builds all XNNPACK Microkernels" ON)
OPTION(XNNPACK_BUILD_BENCHMARKS "Build XNNPACK benchmarks" ON)
OPTION(XNNPACK_USE_SYSTEM_LIBS "Use system-provided dependency libraries" OFF)
OPTION(USE_GNU_SOURCE "Use _GNU_SOURCE macro" OFF)
IF(XNNPACK_BUILD_BENCHMARKS OR XNNPACK_BUILD_TESTS)
  SET(XNNPACK_BUILD_ALL_MICROKERNELS ON)
ENDIF()

# --- [ Determine target processor
IF(CMAKE_OSX_ARCHITECTURES)
  LIST(LENGTH CMAKE_OSX_ARCHITECTURES CMAKE_OSX_ARCHITECTURES_COUNT)
  IF(CMAKE_OSX_ARCHITECTURES_COUNT GREATER 1)
    MESSAGE(FATAL_ERROR "Unsupported XNNPACK build with multiple OSX architectures (${CMAKE_OSX_ARCHITECTURES}). "
      "Specify a single architecture in CMAKE_OSX_ARCHITECTURES and re-configure. ")
  ENDIF()
  IF(NOT CMAKE_OSX_ARCHITECTURES MATCHES "^(x86_64|arm64|arm64e|arm64_32)$")
    MESSAGE(FATAL_ERROR "Unrecognized CMAKE_OSX_ARCHITECTURES value \"${CMAKE_OSX_ARCHITECTURES}\"")
  ENDIF()
  SET(XNNPACK_TARGET_PROCESSOR "${CMAKE_OSX_ARCHITECTURES}")
  ADD_COMPILE_OPTIONS("-Wno-shorten-64-to-32")
ELSEIF(CMAKE_GENERATOR MATCHES "^Visual Studio " AND CMAKE_GENERATOR_PLATFORM)
  IF(CMAKE_GENERATOR_PLATFORM STREQUAL "Win32")
    SET(XNNPACK_TARGET_PROCESSOR "x86")
  ELSEIF(CMAKE_GENERATOR_PLATFORM STREQUAL "x64")
    SET(XNNPACK_TARGET_PROCESSOR "x86_64")
  ELSEIF(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64")
    SET(XNNPACK_TARGET_PROCESSOR "arm64")
  ELSEIF(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64EC")
    SET(XNNPACK_TARGET_PROCESSOR "arm64ec")
  ELSE()
    MESSAGE(FATAL_ERROR "Unsupported Visual Studio architecture \"${CMAKE_GENERATOR_PLATFORM}\"")
  ENDIF()
ELSEIF(CMAKE_SYSTEM_PROCESSOR MATCHES "^i[3-7]86$")
  SET(XNNPACK_TARGET_PROCESSOR "x86")
ELSEIF(CMAKE_SYSTEM_PROCESSOR STREQUAL "AMD64")
  SET(XNNPACK_TARGET_PROCESSOR "x86_64")
ELSEIF(CMAKE_SYSTEM_PROCESSOR MATCHES "^armv[5-8]")
  SET(XNNPACK_TARGET_PROCESSOR "arm")
ELSEIF(CMAKE_SYSTEM_PROCESSOR STREQUAL "aarch64")
  SET(XNNPACK_TARGET_PROCESSOR "arm64")
ELSEIF(CMAKE_SYSTEM_PROCESSOR STREQUAL "ppc64le")
  SET(XNNPACK_TARGET_PROCESSOR "ppc64")
ELSEIF(NOT XNNPACK_TARGET_PROCESSOR MATCHES "^(x86(_64)?|arm64|riscv(32|64|128)|Hexagon|ppc64)$")
  SET(XNNPACK_TARGET_PROCESSOR "${CMAKE_SYSTEM_PROCESSOR}")
ELSE()
  MESSAGE(FATAL_ERROR "Unrecognized CMAKE_SYSTEM_PROCESSOR value \"${CMAKE_SYSTEM_PROCESSOR}\"")
ENDIF()
MESSAGE(STATUS "Building for XNNPACK_TARGET_PROCESSOR: ${XNNPACK_TARGET_PROCESSOR}")

# --- [ Processor-specific options
OPTION(XNNPACK_ENABLE_ARM_FP16_SCALAR "Build XNNPACK with ARM FP16 (FP16 data processing) scalar micro-kernels" ON)
OPTION(XNNPACK_ENABLE_ARM_FP16_VECTOR "Build XNNPACK with ARM FP16 (FP16 data processing) vector micro-kernels" ON)
OPTION(XNNPACK_ENABLE_ARM_BF16 "Build XNNPACK with ARM BF16 (BFLOAT16) micro-kernels" ON)
OPTION(XNNPACK_ENABLE_ARM_DOTPROD "Build XNNPACK with ARM DotProd (integer dot product) micro-kernels" ON)
OPTION(XNNPACK_ENABLE_ARM_I8MM "Build XNNPACK with ARM I8MM (8-bit integer matrix multiply accumulate) micro-kernels" ON)
IF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "11")
    SET(XNNPACK_ENABLE_ARM_I8MM OFF)
  ENDIF()
ENDIF()
OPTION(XNNPACK_ENABLE_RISCV_VECTOR "Build XNNPACK with RISC-V Vector micro-kernels" ON)
OPTION(XNNPACK_ENABLE_VSX "Build XNNPACK with VSX Vector micro-kernels for Power" ON)
OPTION(XNNPACK_ENABLE_AVXVNNI "Build XNNPACK with AVX-VNNI micro-kernels" ON)
IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "11")
    SET(XNNPACK_ENABLE_AVXVNNI OFF)
  ENDIF()
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "15")
    SET(XNNPACK_ENABLE_AVXVNNI OFF)
  ENDIF()
ENDIF()
OPTION(XNNPACK_ENABLE_AVX256SKX "Build XNNPACK with AVX256SKX micro-kernels" ON)
IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "11")
    SET(XNNPACK_ENABLE_AVX256SKX OFF)
  ENDIF()
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "15")
    SET(XNNPACK_ENABLE_AVX256SKX OFF)
  ENDIF()
ENDIF()
OPTION(XNNPACK_ENABLE_AVX256VNNI "Build XNNPACK with AVX256VNNI micro-kernels" ON)
IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "11")
    SET(XNNPACK_ENABLE_AVX256VNNI OFF)
  ENDIF()
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "15")
    SET(XNNPACK_ENABLE_AVX256VNNI OFF)
  ENDIF()
ENDIF()
OPTION(XNNPACK_ENABLE_AVX256VNNIGFNI "Build XNNPACK with AVX256VNNIGFNI micro-kernels" ON)
IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "11")
    SET(XNNPACK_ENABLE_AVX256VNNIGFNI OFF)
  ENDIF()
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "15")
    SET(XNNPACK_ENABLE_AVX256VNNIGFNI OFF)
  ENDIF()
ENDIF()
OPTION(XNNPACK_ENABLE_AVX512VNNIGFNI "Build XNNPACK with AVX512VNNIGFNI micro-kernels" ON)
IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "8")
    SET(XNNPACK_ENABLE_AVX512VNNIGFNI OFF)
  ENDIF()
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "6")
    SET(XNNPACK_ENABLE_AVX512VNNIGFNI OFF)
  ENDIF()
ENDIF()
OPTION(XNNPACK_ENABLE_AVX512AMX "Build XNNPACK with AVX512-AMX micro-kernels" ON)
IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "13")
    SET(XNNPACK_ENABLE_AVX512AMX OFF)
  ENDIF()
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "15")
    SET(XNNPACK_ENABLE_AVX512AMX OFF)
  ENDIF()
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
  SET(XNNPACK_ENABLE_AVX512AMX OFF)
ENDIF()
IF(XNNPACK_TARGET_PROCESSOR STREQUAL "x86")
  SET(XNNPACK_ENABLE_AVX512AMX OFF)
ENDIF()
OPTION(XNNPACK_ENABLE_AVX512FP16 "Build XNNPACK with AVX512-FP16 micro-kernels" ON)
IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "13")
    SET(XNNPACK_ENABLE_AVX512FP16 OFF)
  ENDIF()
ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "15")
    SET(XNNPACK_ENABLE_AVX512FP16 OFF)
  ENDIF()
ENDIF()
OPTION(XNNPACK_ENABLE_HVX "Build XNNPACK with Hexagon HVX micro-kernels" ON)
OPTION(XNNPACK_ENABLE_KLEIDIAI "Use KleidiAI GEMM microkernels for Arm" ON)
IF(XNNPACK_TARGET_PROCESSOR STREQUAL "arm64" AND XNNPACK_ENABLE_ARM_I8MM AND NOT CMAKE_C_COMPILER_ID STREQUAL "MSVC")
  IF (XNNPACK_ENABLE_KLEIDIAI)
    MESSAGE(STATUS "Enabling KleidiAI for Arm64")
  ENDIF()
ELSE()
  SET(XNNPACK_ENABLE_KLEIDIAI OFF)
ENDIF()

# ---[ CMake options
INCLUDE(GNUInstallDirs)

IF(XNNPACK_BUILD_TESTS)
  ENABLE_TESTING()
ENDIF()

ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_FP16_VECTOR=$<BOOL:${XNNPACK_ENABLE_ARM_FP16_VECTOR}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_FP16_SCALAR=$<BOOL:${XNNPACK_ENABLE_ARM_FP16_SCALAR}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_BF16=$<BOOL:${XNNPACK_ENABLE_ARM_BF16}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_DOTPROD=$<BOOL:${XNNPACK_ENABLE_ARM_DOTPROD}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_I8MM=$<BOOL:${XNNPACK_ENABLE_ARM_I8MM}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_RISCV_VECTOR=$<BOOL:${XNNPACK_ENABLE_RISCV_VECTOR}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVXVNNI=$<BOOL:${XNNPACK_ENABLE_AVXVNNI}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX256SKX=$<BOOL:${XNNPACK_ENABLE_AVX256SKX}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX256VNNI=$<BOOL:${XNNPACK_ENABLE_AVX256VNNI}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX256VNNIGFNI=$<BOOL:${XNNPACK_ENABLE_AVX256VNNIGFNI}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX512VNNIGFNI=$<BOOL:${XNNPACK_ENABLE_AVX512VNNIGFNI}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX512AMX=$<BOOL:${XNNPACK_ENABLE_AVX512AMX}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX512FP16=$<BOOL:${XNNPACK_ENABLE_AVX512FP16}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_VSX=$<BOOL:${XNNPACK_ENABLE_VSX}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ASSEMBLY=$<BOOL:${XNNPACK_ENABLE_ASSEMBLY}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_MEMOPT=$<BOOL:${XNNPACK_ENABLE_MEMOPT}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_SPARSE=$<BOOL:${XNNPACK_ENABLE_SPARSE}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_GEMM_M_SPECIALIZATION=$<BOOL:${XNNPACK_ENABLE_GEMM_M_SPECIALIZATION}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_DWCONV_MULTIPASS=$<BOOL:${XNNPACK_ENABLE_DWCONV_MULTIPASS}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_HVX=$<BOOL:${XNNPACK_ENABLE_HVX}>")
ADD_COMPILE_DEFINITIONS("XNN_ENABLE_KLEIDIAI=$<BOOL:${XNNPACK_ENABLE_KLEIDIAI}>")

IF(XNNPACK_TARGET_PROCESSOR MATCHES "Hexagon")
  ADD_COMPILE_DEFINITIONS("XNN_ENABLE_CPUINFO=0")
ELSE()
  ADD_COMPILE_DEFINITIONS("XNN_ENABLE_CPUINFO=1")
ENDIF()

IF(USE_GNU_SOURCE)
  ADD_COMPILE_DEFINITIONS(_GNU_SOURCE)
ENDIF()

IF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
  # Disable "unary minus operator applied to unsigned type, result still unsigned" warning
  ADD_COMPILE_OPTIONS("/wd4146")
  # Test files have many sections, increase the limit. See
  # https://learn.microsoft.com/en-us/cpp/build/reference/bigobj-increase-number-of-sections-in-dot-obj-file.
  ADD_COMPILE_OPTIONS("/bigobj")
ENDIF()

IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  # Disable "note: parameter passing for argument of type ... changed/will change in ..."
  ADD_COMPILE_OPTIONS("-Wno-psabi")
ENDIF()

# ---[ Build flags
IF(NOT CMAKE_SYSTEM_NAME)
  MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_NAME not defined")

=== debian/changelog ===
xnnpack (0.0~git20240821.87ee0b4-3) unstable; urgency=medium

  * Team upload.
  * Mark libxnnpack0 as "Multi-Arch: same"

 -- Dylan Aïssi <daissi@debian.org>  Tue, 21 Jan 2025 12:23:32 +0100

xnnpack (0.0~git20240821.87ee0b4-2) unstable; urgency=medium

  * Team upload.
  * d/rules: disable kleidiai to fix build on arm64 (see: #1081414)
  * d/rules: add exception in CFLAGS to fix build on arm{hf,64}

 -- Shengqi Chen <harry-chen@outlook.com>  Wed, 11 Sep 2024 21:45:39 +0800

xnnpack (0.0~git20240821.87ee0b4-1) unstable; urgency=medium

  [ Shengqi Chen ]
  * Team upload.
  * New upstream version 0.0~git20240821.87ee0b4
    Please use this snapshot for PyTorch/2.4.X releases.
  * d/patches: refresh patch and add DEP3 header
  * d/control: 
    + add python3 in B-D, limit architecture to supported platforms
    + bump std-ver to 4.7.0.1 (no changes required)
  * d/rules:
    + fix indentation
    + remove override_dh_dwz which is now unnecessary
    + fix wrong hardening flags
  * d/copyright: remove unused BSD-2-Clause paragraph

  [ Aron Xu ]
  * d/rules: disable tests for known failures

 -- Shengqi Chen <harry-chen@outlook.com>  Thu, 05 Sep 2024 00:26:23 +0800

xnnpack (0.0~git20240229.fcbf55a-1~exp1) experimental; urgency=medium

  * New upstream version 0.0~git20240229.fcbf55a
    + Please pin to this snapshot for PyTorch/2.3.X release.
  * Refresh existing patches.
  * Add new cmake flags to avoid cmake failure.
  * Add version requirement to pthreadpool.
  * Bump version requirement on B-D cpuinfo.
  * Add a file in not-installed.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Thu, 11 Jul 2024 01:05:18 -0400

=== debian/control ===
Source: xnnpack
Section: math
Homepage: https://github.com/google/XNNPACK
Priority: optional
Standards-Version: 4.7.0.1
Vcs-Git: https://salsa.debian.org/deeplearning-team/xnnpack.git
Vcs-Browser: https://salsa.debian.org/deeplearning-team/xnnpack
Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               googletest,
               libcpuinfo-dev (>= 0.0~git20231104.d6860c4~),
               libfp16-dev,
               libfxdiv-dev,
               libpsimd-dev,
               libpthreadpool-dev (>= 0.0~git20240616.560c60d~),
               ninja-build,
               python3

Package: libxnnpack-dev
Section: libdevel
Architecture: amd64 i386 x32 armhf arm64 riscv64
Depends: libxnnpack0 (= ${binary:Version}), ${misc:Depends}
Description: High-efficiency floating-point neural network inference operators (dev)
 XNNPACK is a highly optimized library of floating-point neural network
 inference operators for ARM, WebAssembly, and x86 platforms. XNNPACK is not
 intended for direct use by deep learning practitioners and researchers; instead
 it provides low-level performance primitives for accelerating high-level
 machine learning frameworks, such as TensorFlow Lite, TensorFlow.js, PyTorch,
 and MediaPipe.
 .
 This package contains the development files.

Package: libxnnpack0
Section: libs
Architecture: amd64 i386 x32 armhf arm64 riscv64
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: High-efficiency floating-point neural network inference operators (libs)
 XNNPACK is a highly optimized library of floating-point neural network
 inference operators for ARM, WebAssembly, and x86 platforms. XNNPACK is not
 intended for direct use by deep learning practitioners and researchers; instead
 it provides low-level performance primitives for accelerating high-level
 machine learning frameworks, such as TensorFlow Lite, TensorFlow.js, PyTorch,
 and MediaPipe.
 .
 This package contains the shared object.

## xnnpack 0.0~git20241108.4ea82e5

=== CMakeLists.txt ===
--- 
+++ 
@@ -79,7 +79,7 @@
   ELSEIF(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64")
     SET(XNNPACK_TARGET_PROCESSOR "arm64")
   ELSEIF(CMAKE_GENERATOR_PLATFORM STREQUAL "ARM64EC")
-    SET(XNNPACK_TARGET_PROCESSOR "arm64ec")
+    SET(XNNPACK_TARGET_PROCESSOR "arm64")
   ELSE()
     MESSAGE(FATAL_ERROR "Unsupported Visual Studio architecture \"${CMAKE_GENERATOR_PLATFORM}\"")
   ENDIF()
@@ -106,10 +106,25 @@
 OPTION(XNNPACK_ENABLE_ARM_BF16 "Build XNNPACK with ARM BF16 (BFLOAT16) micro-kernels" ON)
 OPTION(XNNPACK_ENABLE_ARM_DOTPROD "Build XNNPACK with ARM DotProd (integer dot product) micro-kernels" ON)
 OPTION(XNNPACK_ENABLE_ARM_I8MM "Build XNNPACK with ARM I8MM (8-bit integer matrix multiply accumulate) micro-kernels" ON)
-IF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
-  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "11")
-    SET(XNNPACK_ENABLE_ARM_I8MM OFF)
-  ENDIF()
+OPTION(XNNPACK_ENABLE_ARM_SME "Build XNNPACK with ARM SME micro-kernels" ON)
+OPTION(XNNPACK_ENABLE_ARM_SME2 "Build XNNPACK with ARM SME2 micro-kernels" ON)
+IF(NOT XNNPACK_TARGET_PROCESSOR MATCHES "arm(64)?")
+  SET(XNNPACK_ENABLE_ARM_FP16_SCALAR OFF)
+  SET(XNNPACK_ENABLE_ARM_FP16_VECTOR OFF)
+  SET(XNNPACK_ENABLE_ARM_BF16 OFF)
+  SET(XNNPACK_ENABLE_ARM_DOTPROD OFF)
+ENDIF()
+IF(NOT XNNPACK_TARGET_PROCESSOR STREQUAL "arm64")
+  SET(XNNPACK_ENABLE_ARM_I8MM OFF)
+  SET(XNNPACK_ENABLE_ARM_SME OFF)
+  SET(XNNPACK_ENABLE_ARM_SME2 OFF)
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang" AND CMAKE_C_COMPILER_VERSION VERSION_LESS "11")
+  SET(XNNPACK_ENABLE_ARM_I8MM OFF)
+  SET(XNNPACK_ENABLE_ARM_SME OFF)
+  SET(XNNPACK_ENABLE_ARM_SME2 OFF)
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang" AND CMAKE_C_COMPILER_VERSION VERSION_LESS "18")
+  SET(XNNPACK_ENABLE_ARM_SME OFF)
+  SET(XNNPACK_ENABLE_ARM_SME2 OFF)
 ENDIF()
 OPTION(XNNPACK_ENABLE_RISCV_VECTOR "Build XNNPACK with RISC-V Vector micro-kernels" ON)
 OPTION(XNNPACK_ENABLE_VSX "Build XNNPACK with VSX Vector micro-kernels for Power" ON)
@@ -123,6 +138,19 @@
     SET(XNNPACK_ENABLE_AVXVNNI OFF)
   ENDIF()
 ENDIF()
+OPTION(XNNPACK_ENABLE_AVXVNNIINT8 "Build XNNPACK with AVX-VNNI-INT8 micro-kernels" ON)
+IF(CMAKE_SYSTEM_NAME MATCHES "^(Android|Darwin|iOS)$")
+  SET(XNNPACK_ENABLE_AVXVNNIINT8 OFF)
+ENDIF()
+IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "17")
+    SET(XNNPACK_ENABLE_AVXVNNIINT8 OFF)
+  ENDIF()
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "17")
+    SET(XNNPACK_ENABLE_AVXVNNIINT8 OFF)
+  ENDIF()
+ENDIF()
 OPTION(XNNPACK_ENABLE_AVX256SKX "Build XNNPACK with AVX256SKX micro-kernels" ON)
 IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
   IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "11")
@@ -151,6 +179,46 @@
 ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
   IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "15")
     SET(XNNPACK_ENABLE_AVX256VNNIGFNI OFF)
+  ENDIF()
+ENDIF()
+OPTION(XNNPACK_ENABLE_AVX512F "Build XNNPACK with AVX512F micro-kernels" ON)
+IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "8")
+    SET(XNNPACK_ENABLE_AVX512F OFF)
+  ENDIF()
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "6")
+    SET(XNNPACK_ENABLE_AVX512F OFF)
+  ENDIF()
+ENDIF()
+OPTION(XNNPACK_ENABLE_AVX512SKX "Build XNNPACK with AVX512SKX micro-kernels" ON)
+IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "8")
+    SET(XNNPACK_ENABLE_AVX512SKX OFF)
+  ENDIF()
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "6")
+    SET(XNNPACK_ENABLE_AVX512SKX OFF)
+  ENDIF()
+ENDIF()
+OPTION(XNNPACK_ENABLE_AVX512VBMI "Build XNNPACK with AVX512VBMI micro-kernels" ON)
+IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "8")
+    SET(XNNPACK_ENABLE_AVX512VBMI OFF)
+  ENDIF()
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "6")
+    SET(XNNPACK_ENABLE_AVX512VBMI OFF)
+  ENDIF()
+ENDIF()
+OPTION(XNNPACK_ENABLE_AVX512VNNI "Build XNNPACK with AVX512VNNI micro-kernels" ON)
+IF(CMAKE_C_COMPILER_ID STREQUAL "GNU")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "8")
+    SET(XNNPACK_ENABLE_AVX512VNNI OFF)
+  ENDIF()
+ELSEIF(CMAKE_C_COMPILER_ID STREQUAL "Clang")
+  IF(CMAKE_C_COMPILER_VERSION VERSION_LESS "6")
+    SET(XNNPACK_ENABLE_AVX512VNNI OFF)
   ENDIF()
 ENDIF()
 OPTION(XNNPACK_ENABLE_AVX512VNNIGFNI "Build XNNPACK with AVX512VNNIGFNI micro-kernels" ON)
@@ -206,50 +274,3 @@
 ENDIF()
 
 ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_FP16_VECTOR=$<BOOL:${XNNPACK_ENABLE_ARM_FP16_VECTOR}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_FP16_SCALAR=$<BOOL:${XNNPACK_ENABLE_ARM_FP16_SCALAR}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_BF16=$<BOOL:${XNNPACK_ENABLE_ARM_BF16}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_DOTPROD=$<BOOL:${XNNPACK_ENABLE_ARM_DOTPROD}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ARM_I8MM=$<BOOL:${XNNPACK_ENABLE_ARM_I8MM}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_RISCV_VECTOR=$<BOOL:${XNNPACK_ENABLE_RISCV_VECTOR}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVXVNNI=$<BOOL:${XNNPACK_ENABLE_AVXVNNI}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX256SKX=$<BOOL:${XNNPACK_ENABLE_AVX256SKX}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX256VNNI=$<BOOL:${XNNPACK_ENABLE_AVX256VNNI}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX256VNNIGFNI=$<BOOL:${XNNPACK_ENABLE_AVX256VNNIGFNI}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX512VNNIGFNI=$<BOOL:${XNNPACK_ENABLE_AVX512VNNIGFNI}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX512AMX=$<BOOL:${XNNPACK_ENABLE_AVX512AMX}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_AVX512FP16=$<BOOL:${XNNPACK_ENABLE_AVX512FP16}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_VSX=$<BOOL:${XNNPACK_ENABLE_VSX}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_ASSEMBLY=$<BOOL:${XNNPACK_ENABLE_ASSEMBLY}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_MEMOPT=$<BOOL:${XNNPACK_ENABLE_MEMOPT}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_SPARSE=$<BOOL:${XNNPACK_ENABLE_SPARSE}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_GEMM_M_SPECIALIZATION=$<BOOL:${XNNPACK_ENABLE_GEMM_M_SPECIALIZATION}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_DWCONV_MULTIPASS=$<BOOL:${XNNPACK_ENABLE_DWCONV_MULTIPASS}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_HVX=$<BOOL:${XNNPACK_ENABLE_HVX}>")
-ADD_COMPILE_DEFINITIONS("XNN_ENABLE_KLEIDIAI=$<BOOL:${XNNPACK_ENABLE_KLEIDIAI}>")
-
-IF(XNNPACK_TARGET_PROCESSOR MATCHES "Hexagon")
-  ADD_COMPILE_DEFINITIONS("XNN_ENABLE_CPUINFO=0")
-ELSE()
-  ADD_COMPILE_DEFINITIONS("XNN_ENABLE_CPUINFO=1")
-ENDIF()
-
-IF(USE_GNU_SOURCE)
-  ADD_COMPILE_DEFINITIONS(_GNU_SOURCE)
-ENDIF()
-
-IF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
-  # Disable "unary minus operator applied to unsigned type, result still unsigned" warning
-  ADD_COMPILE_OPTIONS("/wd4146")
-  # Test files have many sections, increase the limit. See
-  # https://learn.microsoft.com/en-us/cpp/build/reference/bigobj-increase-number-of-sections-in-dot-obj-file.
-  ADD_COMPILE_OPTIONS("/bigobj")
-ENDIF()
-
-IF(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
-  # Disable "note: parameter passing for argument of type ... changed/will change in ..."
-  ADD_COMPILE_OPTIONS("-Wno-psabi")
-ENDIF()
-
-# ---[ Build flags
-IF(NOT CMAKE_SYSTEM_NAME)
-  MESSAGE(FATAL_ERROR "CMAKE_SYSTEM_NAME not defined")

=== debian/changelog ===
xnnpack (0.0~git20241108.4ea82e5-2) unstable; urgency=medium

  * Gbp-Dch: bump std-ver to 4.7.2 (no changes required).
  * d/{control,rules}: build with kleidiai on arm64.
  * d/control: mark libxnnpack-dev as Multi-Arch: same.

 -- Shengqi Chen <harry@debian.org>  Sun, 13 Apr 2025 15:11:05 +0800

xnnpack (0.0~git20241108.4ea82e5-1) unstable; urgency=medium

  * d/control: add myself in uploaders
  * Upload to unstable.

 -- Shengqi Chen <harry@debian.org>  Mon, 17 Feb 2025 23:45:51 +0800

xnnpack (0.0~git20241108.4ea82e5-1~exp2) experimental; urgency=medium

  * Team upload.
  * d/patches: backport FTBFS fix with GCC 13 on arm64 from upstream

 -- Shengqi Chen <harry@debian.org>  Sun, 26 Jan 2025 00:01:33 +0800

xnnpack (0.0~git20241108.4ea82e5-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 0.0~git20241108.4ea82e5
    Please use this snapshot for PyTorch/2.6+ releases.
  * Install libmicrokernels-prod.a in libxnnpack-dev
  * d/control: use correct std-ver 4.7.0
  * Bump SOVERSION to libxnnpack0.20241108 to reflect API changes
  * d/copyright: add new author names according to upstream

 -- Shengqi Chen <harry@debian.org>  Fri, 24 Jan 2025 13:57:27 +0800

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,11 @@
 Section: math
 Homepage: https://github.com/google/XNNPACK
 Priority: optional
-Standards-Version: 4.7.0.1
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/xnnpack.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/xnnpack
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
-Uploaders: Mo Zhou <lumin@debian.org>
+Uploaders: Mo Zhou <lumin@debian.org>, Shengqi Chen <harry@debian.org>
 Rules-Requires-Root: no
 Build-Depends: cmake,
                debhelper-compat (= 13),
@@ -14,6 +14,7 @@
                libcpuinfo-dev (>= 0.0~git20231104.d6860c4~),
                libfp16-dev,
                libfxdiv-dev,
+               libkleidiai-dev [arm64],
                libpsimd-dev,
                libpthreadpool-dev (>= 0.0~git20240616.560c60d~),
                ninja-build,
@@ -22,7 +23,8 @@
 Package: libxnnpack-dev
 Section: libdevel
 Architecture: amd64 i386 x32 armhf arm64 riscv64
-Depends: libxnnpack0 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
+Depends: libxnnpack0.20241108 (= ${binary:Version}), ${misc:Depends}
 Description: High-efficiency floating-point neural network inference operators (dev)
  XNNPACK is a highly optimized library of floating-point neural network
  inference operators for ARM, WebAssembly, and x86 platforms. XNNPACK is not
@@ -33,7 +35,7 @@
  .
  This package contains the development files.
 
-Package: libxnnpack0
+Package: libxnnpack0.20241108
 Section: libs
 Architecture: amd64 i386 x32 armhf arm64 riscv64
 Multi-Arch: same
@@ -46,4 +48,4 @@
  machine learning frameworks, such as TensorFlow Lite, TensorFlow.js, PyTorch,
  and MediaPipe.
  .
- This package contains the shared object.
+ This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# upstream CI has numerous warnings, do not treat as errors.
export DEB_CFLAGS_MAINT_APPEND = -fPIC -Wno-incompatible-pointer-types

include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

USE_KLEIDIAI=OFF
ifeq ($(DEB_HOST_ARCH),arm64)
USE_KLEIDIAI=ON
endif

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- \
        -DXNNPACK_LIBRARY_TYPE=shared \
        -DXNNPACK_USE_SYSTEM_LIBS=ON \
        -DXNNPACK_BUILD_TESTS=OFF \
        -DXNNPACK_BUILD_BENCHMARKS=OFF \
	-DXNNPACK_ENABLE_KLEIDIAI=$(USE_KLEIDIAI) \
        -DGOOGLETEST_SOURCE_DIR=/usr/src/googletest \
        -DPTHREADPOOL_SOURCE_DIR=/usr \
        -DCPUINFO_SOURCE_DIR=/usr

override_dh_auto_test:
	#dh_auto_test

=== debian/watch ===
version=4
opts="mode=git, pgpmode=none" \
https://github.com/google/XNNPACK \
HEAD debian uupdate
